iic: xiic_multi_master_example.c File Reference

| iic Xilinx SDK Drivers API Documentation

- Overview
- Data Structures
- APIs
- File List
- Examples

Functions
xiic_multi_master_example.c File Reference

## Overview

This file consists of a Interrupt mode design example which uses the Xilinx IIC device and XIic driver to exercise the EEPROM on the Xilinx boards in a Multi master mode.

This example has been tested with an off-board external IIC Master connected on the IIC bus.

This example writes/reads from the lower 256 bytes of the IIC EEPROMS. Please refer to the datasheets of the IIC EEPROM's for details about the internal addressing and page size of these devices.

The XIic_MasterSend() API is used to transmit the data and XIic_MasterRecv() API is used to receive the data.

The example is tested on ML300/ML310/ML403/ML501 Xilinx boards.

The ML310/ML410/ML510 boards have a on-board 64 Kb serial IIC EEPROM (Microchip 24LC64A). The WP pin of the IIC EEPROM is hardwired to ground on this board.

The ML300 board has an on-board 32 Kb serial IIC EEPROM(Microchip 24LC32A). The WP pin of the IIC EEPROM has to be connected to ground for this example. The WP is connected to pin Y3 of the FPGA.

The ML403 board has an on-board 4 Kb serial IIC EEPROM(Microchip 24LC04A). The WP pin of the IIC EEPROM is hardwired to ground on this board.

The ML501/ML505/ML507/ML605/SP601/SP605 boards have an on-board 8 Kb serial IIC EEPROM(STM M24C08). The WP pin of the IIC EEPROM is hardwired to ground on these boards.

The AddressType for ML300/ML310/ML410/ML510 boards should be u16 as the address pointer in the on board EEPROM is 2 bytes.

The AddressType for ML403/ML501/ML505/ML507/ML605/SP601/SP605 boards should be u8 as the address pointer for the on board EEPROM is 1 byte.

The 7 bit IIC Slave address of the IIC EEPROM on the ML300/ML310/ML403/ML410/ ML501/ML505/ML507/ML510 boards is 0x50. The 7 bit IIC Slave address of the IIC EEPROM on the ML605/SP601/SP605 boards is 0x54. Refer to the User Guide's of the respective boards for further information about the IIC slave address of IIC EEPROM's.

The define EEPROM_ADDRESS in this file needs to be changed depending on the board on which this example is to be run. This code assumes that no Operating System is being used.

Note

None.

    MODIFICATION HISTORY:

    Ver   Who  Date  Changes

    1.00a mta  03/01/06 Created.
    2.00a sdm  09/22/09 Converted all register accesses to 32 bit access.
                  Updated to use the HAL APIs, replaced call to
                  XIic_Initialize API with XIic_LookupConfig and
                  XIic_CfgInitialize.
    2.01a ktn  03/17/10 Updated the information about the EEPROM's used on
                  ML605/SP601/SP605 boards.
    3.4   ms   01/23/17 Added xil_printf statement in main function to
                        ensure that "Successfully ran" and "Failed" strings
                        are available in all examples. This is a fix for
                        CR-965028.

## Functions
int | IicMultiMasterExample ()
| This function writes the data to the IIC EEPROM. More...
int | main (void)
| Main function to call the Multi Master example. More...

## Function Documentation

int IicMultiMasterExample | ( |  | ) |

This function writes the data to the IIC EEPROM.

Parameters

  None. |

Returns
  XST_SUCCESS if successful else XST_FAILURE.

Note
  None.

References XIic_Config::BaseAddress, XIic::Stats, XIicStats::TxErrors, XII_ADDR_TO_SEND_TYPE, XIic_CfgInitialize(), XIic_LookupConfig(), XIic_MasterSend(), XIic_MultiMasterInclude(), XIic_SetAddress(), XIic_SetSendHandler(), XIic_SetStatusHandler(), XIic_Start(), and XIic_Stop().

Referenced by main().

int main | ( | void |  | ) |

Main function to call the Multi Master example.

Parameters

  None. |

Returns
  XST_SUCCESS if successful else XST_FAILURE.

Note
  None.

References IicMultiMasterExample().